<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfIadeOdeme ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfIadeOdeme
 * @subpackage Arrays
 */
class ArrayOfIadeOdeme extends AbstractStructArrayBase
{
    /**
     * The IadeOdeme
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\IadeOdeme[]
     */
    public $IadeOdeme;
    /**
     * Constructor method for ArrayOfIadeOdeme
     * @uses ArrayOfIadeOdeme::setIadeOdeme()
     * @param \StructType\IadeOdeme[] $iadeOdeme
     */
    public function __construct(array $iadeOdeme = array())
    {
        $this
            ->setIadeOdeme($iadeOdeme);
    }
    /**
     * Get IadeOdeme value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\IadeOdeme[]|null
     */
    public function getIadeOdeme()
    {
        return isset($this->IadeOdeme) ? $this->IadeOdeme : null;
    }
    /**
     * This method is responsible for validating the values passed to the setIadeOdeme method
     * This method is willingly generated in order to preserve the one-line inline validation within the setIadeOdeme method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateIadeOdemeForArrayConstraintsFromSetIadeOdeme(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfIadeOdemeIadeOdemeItem) {
            // validation for constraint: itemType
            if (!$arrayOfIadeOdemeIadeOdemeItem instanceof \StructType\IadeOdeme) {
                $invalidValues[] = is_object($arrayOfIadeOdemeIadeOdemeItem) ? get_class($arrayOfIadeOdemeIadeOdemeItem) : sprintf('%s(%s)', gettype($arrayOfIadeOdemeIadeOdemeItem), var_export($arrayOfIadeOdemeIadeOdemeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The IadeOdeme property can only contain items of type \StructType\IadeOdeme, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set IadeOdeme value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\IadeOdeme[] $iadeOdeme
     * @return \ArrayType\ArrayOfIadeOdeme
     */
    public function setIadeOdeme(array $iadeOdeme = array())
    {
        // validation for constraint: array
        if ('' !== ($iadeOdemeArrayErrorMessage = self::validateIadeOdemeForArrayConstraintsFromSetIadeOdeme($iadeOdeme))) {
            throw new \InvalidArgumentException($iadeOdemeArrayErrorMessage, __LINE__);
        }
        if (is_null($iadeOdeme) || (is_array($iadeOdeme) && empty($iadeOdeme))) {
            unset($this->IadeOdeme);
        } else {
            $this->IadeOdeme = $iadeOdeme;
        }
        return $this;
    }
    /**
     * Add item to IadeOdeme value
     * @throws \InvalidArgumentException
     * @param \StructType\IadeOdeme $item
     * @return \ArrayType\ArrayOfIadeOdeme
     */
    public function addToIadeOdeme(\StructType\IadeOdeme $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\IadeOdeme) {
            throw new \InvalidArgumentException(sprintf('The IadeOdeme property can only contain items of type \StructType\IadeOdeme, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->IadeOdeme[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\IadeOdeme|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\IadeOdeme|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\IadeOdeme|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\IadeOdeme|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\IadeOdeme|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string IadeOdeme
     */
    public function getAttributeName()
    {
        return 'IadeOdeme';
    }
}
