<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SaveKargoTakipNo StructType
 * @subpackage Structs
 */
class SaveKargoTakipNo extends AbstractStructBase
{
    /**
     * The UyeKodu
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $UyeKodu;
    /**
     * The siparisId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $siparisId;
    /**
     * The kargoKodu
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $kargoKodu;
    /**
     * The kargoTakipNo
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $kargoTakipNo;
    /**
     * The kargoTakipLink
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $kargoTakipLink;
    /**
     * Constructor method for SaveKargoTakipNo
     * @uses SaveKargoTakipNo::setUyeKodu()
     * @uses SaveKargoTakipNo::setSiparisId()
     * @uses SaveKargoTakipNo::setKargoKodu()
     * @uses SaveKargoTakipNo::setKargoTakipNo()
     * @uses SaveKargoTakipNo::setKargoTakipLink()
     * @param string $uyeKodu
     * @param int $siparisId
     * @param string $kargoKodu
     * @param string $kargoTakipNo
     * @param string $kargoTakipLink
     */
    public function __construct($uyeKodu = null, $siparisId = null, $kargoKodu = null, $kargoTakipNo = null, $kargoTakipLink = null)
    {
        $this
            ->setUyeKodu($uyeKodu)
            ->setSiparisId($siparisId)
            ->setKargoKodu($kargoKodu)
            ->setKargoTakipNo($kargoTakipNo)
            ->setKargoTakipLink($kargoTakipLink);
    }
    /**
     * Get UyeKodu value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getUyeKodu()
    {
        return isset($this->UyeKodu) ? $this->UyeKodu : null;
    }
    /**
     * Set UyeKodu value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $uyeKodu
     * @return \StructType\SaveKargoTakipNo
     */
    public function setUyeKodu($uyeKodu = null)
    {
        // validation for constraint: string
        if (!is_null($uyeKodu) && !is_string($uyeKodu)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($uyeKodu, true), gettype($uyeKodu)), __LINE__);
        }
        if (is_null($uyeKodu) || (is_array($uyeKodu) && empty($uyeKodu))) {
            unset($this->UyeKodu);
        } else {
            $this->UyeKodu = $uyeKodu;
        }
        return $this;
    }
    /**
     * Get siparisId value
     * @return int|null
     */
    public function getSiparisId()
    {
        return $this->siparisId;
    }
    /**
     * Set siparisId value
     * @param int $siparisId
     * @return \StructType\SaveKargoTakipNo
     */
    public function setSiparisId($siparisId = null)
    {
        // validation for constraint: int
        if (!is_null($siparisId) && !(is_int($siparisId) || ctype_digit($siparisId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($siparisId, true), gettype($siparisId)), __LINE__);
        }
        $this->siparisId = $siparisId;
        return $this;
    }
    /**
     * Get kargoKodu value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getKargoKodu()
    {
        return isset($this->kargoKodu) ? $this->kargoKodu : null;
    }
    /**
     * Set kargoKodu value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $kargoKodu
     * @return \StructType\SaveKargoTakipNo
     */
    public function setKargoKodu($kargoKodu = null)
    {
        // validation for constraint: string
        if (!is_null($kargoKodu) && !is_string($kargoKodu)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($kargoKodu, true), gettype($kargoKodu)), __LINE__);
        }
        if (is_null($kargoKodu) || (is_array($kargoKodu) && empty($kargoKodu))) {
            unset($this->kargoKodu);
        } else {
            $this->kargoKodu = $kargoKodu;
        }
        return $this;
    }
    /**
     * Get kargoTakipNo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getKargoTakipNo()
    {
        return isset($this->kargoTakipNo) ? $this->kargoTakipNo : null;
    }
    /**
     * Set kargoTakipNo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $kargoTakipNo
     * @return \StructType\SaveKargoTakipNo
     */
    public function setKargoTakipNo($kargoTakipNo = null)
    {
        // validation for constraint: string
        if (!is_null($kargoTakipNo) && !is_string($kargoTakipNo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($kargoTakipNo, true), gettype($kargoTakipNo)), __LINE__);
        }
        if (is_null($kargoTakipNo) || (is_array($kargoTakipNo) && empty($kargoTakipNo))) {
            unset($this->kargoTakipNo);
        } else {
            $this->kargoTakipNo = $kargoTakipNo;
        }
        return $this;
    }
    /**
     * Get kargoTakipLink value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getKargoTakipLink()
    {
        return isset($this->kargoTakipLink) ? $this->kargoTakipLink : null;
    }
    /**
     * Set kargoTakipLink value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $kargoTakipLink
     * @return \StructType\SaveKargoTakipNo
     */
    public function setKargoTakipLink($kargoTakipLink = null)
    {
        // validation for constraint: string
        if (!is_null($kargoTakipLink) && !is_string($kargoTakipLink)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($kargoTakipLink, true), gettype($kargoTakipLink)), __LINE__);
        }
        if (is_null($kargoTakipLink) || (is_array($kargoTakipLink) && empty($kargoTakipLink))) {
            unset($this->kargoTakipLink);
        } else {
            $this->kargoTakipLink = $kargoTakipLink;
        }
        return $this;
    }
}
